#define SHOKI_TYPE      "SESSION"
#define SHOKI_LOG_NAME	SHOKI_LOG_NAME_SESSION

#define TOK_START	1
#define TOK_STOP	2
#define TOK_HOST	3
#define TOK_FILTER	4
#define TOK_REGEX	5
#define TOK_NONCE	6

#define ipaddr_string(p) getname((const u_char *)(p))

struct tconv
{
        struct in_addr src;
        struct in_addr dst;
        u_int port;
};
struct thash
{
        struct thash *next;
        struct tconv addr;
        char *tvp;
        char *ip;
        char *tp;
        tcp_seq seq;
        tcp_seq ack;
};
#define THASHSIZE1	1031
#define THASHSIZE2	8009


int pf_outformat_d[] =
{
	PF_NAME,
	PF_TIME,
	PF_SRC,
	PF_SPORT,
	PF_DST,
	PF_DPORT,
	PF_PROTO,
	PF_FLAGS,
	0,
};

char *pf_outdelim_d[] =
{
	" ",
	" ",
	":",
	" -> ",
	":",
	" ",
	" ",
	0,
};

int pf_type_d[] =
{
	PF_TYPE_VAR,
	PF_TYPE_DELIM,
	PF_TYPE_VAR,
	PF_TYPE_DELIM,
	PF_TYPE_VAR,
	PF_TYPE_DELIM,
	PF_TYPE_VAR,
	PF_TYPE_DELIM,
	PF_TYPE_VAR,
	PF_TYPE_DELIM,
	PF_TYPE_VAR,
	PF_TYPE_DELIM,
	PF_TYPE_VAR,
	PF_TYPE_DELIM,
	PF_TYPE_VAR,
	0,
};

void read_dump(char *);
void read_zdumps(char *, pcap_handler);
void cleanup(int);
void clean_kids();
void parse_input(char *);
void parse_line(char *);
void parse_header(const u_char *, int, int, const struct pcap_pkthdr *);
void parse_packet(register const u_char *, register u_int, register const u_char *, register u_char, register const struct timeval *, int);
void print_conv();
void print_count();

#define SWAPLONG(y) \
((((y)&0xff)<<24) | (((y)&0xff00)<<8) | (((y)&0xff0000)>>8) | (((y)>>24)&0xff))
#define TCPDUMP_MAGIC 0xa1b2c3d4


