#!/bin/sh
#
# This is just a little script used to initialise a postgres database for
# keeping track of incidents.

# Comment out the following two lines and set DIR below
#
#
echo "Read this script before running it."
exit 1

# /tmp is probably a bad choice.  If you don't understand about /tmp
# race conditions, set this to something else.
DIR=/tmp
#
# Set the value of DB to whatever you want the database to be called.
# Make sure you don't already have a database of the same name.
DB=alerts
#
# Set the value of TABLE to whatever you want the table to be called.
TABLE=alerts
#
# Set the value of LUSER to whatever luser you're planning on running
# the data collection/parsing/analysis widgetry as.  Note that this
# is the luser on the central machine(s) that's doing the work---not
# the sensor.
LUSER=root

cat <<EOF > ${DIR}/alerts.psql
create table ${TABLE}
	(timestamp int,
	level int,
	alert varchar(128));
create function abstime_datetime(int4)
        returns datetime
        as '' language 'internal';
create function datetime(int4)
        returns datetime
        as 'select abstime_datetime(\$1)' language 'sql';
create function reltime_timespan(int4)
        returns timespan
        as '' language 'internal';
create function timespan(int4)
        returns timespan
        as 'select reltime_timespan(\$1)' language 'sql';
create user ${LUSER};
grant select on ${TABLE} to ${LUSER};
grant delete on ${TABLE} to ${LUSER};
grant insert on ${TABLE} to ${LUSER};
EOF
chmod 444 ${DIR}/alerts.psql

su -c "createdb ${DB}" - postgres
su -c "psql -d ${DB} -f ${DIR}/alerts.psql" - postgres


exit 0
