#!/usr/bin/perl
#
# This script can be invoked via cron(8) or some such to force a sensor
# dump rotation if the current time is more that $ROTATE_CUTTOFF seconds
# after the time the current dump started.
#
# This shouldn't be necessary if you're calling ./sensor.init restart
# on a regular basis.
#

$shoki_conf = '/usr/local/net/ids/etc/shoki.conf';

&main();
exit(0);


sub main
{
	&read_config($shoki_conf);
	&check_current();
}

sub check_current
{
	my($foo, $bar);
	chomp($foo = `/bin/cat $CURRENTDUMP`);
	($foo =~ /sensor_dump\.(\d+)$/) && ($bar = $1);
	$bar || exit(1);
	$foo = time - $ROTATE_CUTOFF;
	($bar < $foo) || exit(0);
	system("$SENSORINIT restart");
}

sub read_config
{
	my($fname) = @_;
	open(FILE, "<$fname") ||
		(die "Couldn't read $fname");
	while(<FILE>)
	{
		/^(\w+)(\s*)=(\s*)(.+)$/ || next;
		${$1} = $4;
	}
	close(FILE);
}
